<?php

namespace NCSU\ItecsDuskMacros\Tests;

// Mock the Browser Macro interface
// c.f. https://ericdraken.com/phpunit-mock-hard-dependencies-aliases/
use Closure;

class DuskBrowserMock
{
    public static $macros;
    const SPACE = ' ';
    public $driver;

    public function __construct()
    {
        $this->driver = $this;
    }

    public function manage()
    {
        return $this;
    }
    public function getLog($typeOfLog)
    {
        return [
            ['level' => 'INFO', 'message' => $typeOfLog],
            ['level' => 'ERROR', 'message' => 'NOOOOOO'],
            ['level' => 'WARNING', 'message' => 'YAY!'],
            ['level' => 'WHATEV', 'message' => 'WAT'],
        ];
    }

    public function value($selector)
    {
        return $selector;
    }

    public function keys($selector, $arr, $val)
    {
        return $this;
    }

    public function script($val)
    {
        return $this;
    }

    public function element($selector)
    {
        return $this;
    }
    public function sendKeys($keys)
    {
        return $this;
    }

    public function click($selector='')
    {
        return $this;
    }

    public function waitFor($arg)
    {
        return $this;
    }
    public function xpath($arg)
    {
        return $this;
    }
    public function optionXPathByText($arg)
    {
        return $this;
    }
    public function findElement($arg)
    {
        return $this;
    }
    public function pause($arg)
    {
        return $this;
    }
    public static function macro($name, Closure $closure)
    {
        self::$macros[$name] = $closure;
    }

    public static function __callStatic($method, $parameters)
    {
        $macro = static::$macros[$method];
        $macro = $macro->bindTo(null, static::class);
        return $macro(...$parameters);
    }

    public function __call($method, $parameters)
    {
        $macro = static::$macros[$method];
        $macro = $macro->bindTo($this, static::class);
        return $macro(...$parameters);
    }
}
DuskBrowserMock::$macros = [];


